#include <alloc.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "definiri.h"

extern far char optim;
extern far char TipFour;
extern far double **tab;
extern far double *ybin;
extern far double *procente;
extern far void CalculIesiriBinare(double *p,double *y);
extern far double **Matrice(int M,int N);
extern far double *Vector(int N);
extern far void DealocMatrice(double **m,int M);
extern far void DealocVector(double *m);
extern far void Fourier(unsigned char *semnal,int N,double *p_in);



char ValoareLingvistica[4][12]={"foarte mica","mica","mare","medie"};
char NrVirfuri[4][3]={"1 ","2 ","4 ","3 "};
char model[10][8]={{0,0,0,0,0,0,0,0},
		   {0,0x10,0,0x02,0,0x40,0,0},
		   {0x01,0,0x44,0x10,0,0x0A,0x20,0},
		   {0x09,0,0x44,0x10,0x44,0x08,0x20,0x04},
		   {0x29,0,0x44,0x11,0x44,0x0A,0x20,0x14},
		   {0xA9,0x10,0xC4,0x51,0x45,0x8A,0x22,0x94},
		   {0xEE,0xF7,0x76,0xED,0xEF,0xD5,0xDB,0xF7},
		   {0xFE,0xFF,0x77,0xEF,0xFF,0xF5,0xDF,0xFF},
		   {0xFF,0xEF,0xFF,0xFD,0xFF,0xBF,0xFF,0xFF},
		   {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}};

double f(double Inspir,double Expir,double Platou,double x,int NrVirf,double **tab)
    {
    double temp;
    int i,ant;
    double pi;

    pi=acos(-1);

    if (x<Inspir)
       {
       temp=(x-1.226*Inspir)/0.6962/Inspir;
       temp=exp(-temp*temp);
       if (x<0.1696*Inspir)
	  temp-=(x-0.1696*Inspir)*(x-0.1696*Inspir)/Inspir/Inspir*1.5644;
       }
    else
       if (x<=Inspir+Platou)
	  {
	  for (i=1,ant=0;i<4*NrVirf-1;i++)
	     if (tab[i-1][1]<=x)
		ant=i-1;
	  i=ant+1;
	  if (i%2==1)
	     temp=0.9+tab[i][0]*sin((x-tab[i-1][1])/(tab[i][1]-tab[i-1][1])*pi/2);
	  else
	     temp=0.9+tab[i-1][0]*cos((x-tab[i-1][1])/(tab[i][1]-tab[i-1][1])*pi/2);
	  }
       else
	  if (x<=Inspir+Platou+Expir)
	     {
	     temp=(x-Inspir-Platou+Expir*0.226)/0.6962/Expir;
	     temp=exp(-temp*temp);
	     if (x>Inspir+Platou+0.8304*Expir)
		temp-=(x-Inspir-Platou-0.8304*Expir)*(x-Inspir-Platou-0.8304*Expir)/Expir/Expir*1.5644;
	     }
	  else
	     temp=0.0;
    return (temp);
    }

void AfisareIesiri(double *p_out,double *procente,int indicator)
    {
    int i,j;
    char ch,sir[30];
    setviewport(Fereastra2,1);
    setlinestyle(SOLID_LINE,1,NORM_WIDTH);
    setcolor(getmaxcolor());
    settextjustify(CENTER_TEXT,TOP_TEXT);
    setfillstyle(SOLID_FILL,getbkcolor());
    bar(0,60*indicator+10,440,90*indicator+65);
    for (i=0;i<5;i++)
	for (j=0;j<(3+indicator);j++)
	    rectangle(i*88,j*10+60*indicator+10,i*88+88,j*10+20+60*indicator);
    settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
    outtextxy(44,12+60*indicator,"Inspiratia");
    outtextxy(132,12+60*indicator,"Platoul");
    outtextxy(220,12+60*indicator,"Expiratia");
    outtextxy(302,12+60*indicator,"Perioada");
    outtextxy(396,12+60*indicator,"Riplul");
    ch=p_out[0]+p_out[1]*2.0;
    outtextxy(44,22+60*indicator,ValoareLingvistica[ch]);
    ch=p_out[2]+p_out[3]*2.0;
    outtextxy(132,22+60*indicator,ValoareLingvistica[ch]);
    ch=p_out[4]+p_out[5]*2.0;
    outtextxy(220,22+60*indicator,ValoareLingvistica[ch]);
    ch=p_out[6]+p_out[7]*2.0;
    outtextxy(302,22+60*indicator,ValoareLingvistica[ch]);
    ch=p_out[8]+1;
    outtextxy(396,22+60*indicator,ValoareLingvistica[ch]);
    ch=p_out[9]+2*p_out[10];
    outtextxy(90,55+70*indicator,"Nr. Virfuri:");
    outtextxy(160,55+70*indicator,NrVirfuri[ch]);
    if (indicator==0)
	{
	line(396,31,396,39);
	setlinestyle(SOLID_LINE,1,THICK_WIDTH);
	setcolor(LIGHTRED);
	for (i=0;i<5;i++)
	    line(i*88+procente[i]*88,31,i*88+procente[i]*88,39);
	}
    else
	{
	rectangle(200,125,288,135);
	rectangle(200,135,288,145);
	line(244,125,244,145);
	for (i=0;i<8;i++)
	    {
	    j=10*procente[i];
	    setfillpattern(model[j], getmaxcolor());
	    bar((i+1-2*(i%2))*44+1,31+60*indicator,(i+1-2*(i%2))*44+43,39+60*indicator);
	    }
	j=10*procente[8];
	setfillpattern(model[j], getmaxcolor());
	bar(353,31+60*indicator,439,39+60*indicator);

	j=10*procente[10];
	setfillpattern(model[j], getmaxcolor());
	bar(201,126,243,134);
	j=10*procente[9];
	setfillpattern(model[j], getmaxcolor());
	bar(245,126,287,134);

	setcolor(getmaxcolor());
	for (i=0;i<4;i++)
	    line(i*88+44,30+60*indicator,i*88+44,50+60*indicator);
	for (i=0;i<8;i++)
	    {
	    sprintf(sir,"%3.2f",procente[i]);
	    outtextxy((i+1-2*(i%2))*44+22,42+60*indicator,sir);
	    }
	sprintf(sir,"%3.2f",procente[8]);
	outtextxy(396,42+60*indicator,sir);

	sprintf(sir,"%3.2f",procente[10]);
	outtextxy(222,137,sir);
	sprintf(sir,"%3.2f",procente[9]);
	outtextxy(266,137,sir);
	}
    settextjustify(LEFT_TEXT,TOP_TEXT);
    setfillstyle(SOLID_FILL,getmaxcolor()/2);
    setlinestyle(SOLID_LINE,1,NORM_WIDTH);
    }

char Clasificare(double var,double inf,double sup,double *procent)
    {
    char rez;
    if (var<=(sup-inf)/2.0+inf)
       if (var<=(sup-inf)/4.0+inf)
	  {
	  rez=0;
	  *procent=(var-inf)*4/(sup-inf);
	  }
       else
	  {
	  rez=1;
	  *procent=(var-inf-(sup-inf)/4.0)*4/(sup-inf);
	  }
    else
       if (var<=(sup-inf)*3.0/4.0+inf)
	  {
	  rez=3;
	  *procent=(var-inf-(sup-inf)/2.0)*4/(sup-inf);
	  }
       else
	  {
	  rez=2;
	  *procent=(var-inf-(sup-inf)/4.0*3)*4/(sup-inf);
	  }
    return(rez);
    }

void afiseaza_functie(int xstsus,int ystsus,int xdrjos,int ydrjos,double Tmax,double *p_in,double *p_out,int NrIntrari,int NrIesiri)
    {
    char ch,sir[30];
    int NrVirf,i;
    double interx,intery;

    double punct1,punct2,punct3,Inspir,Expir,Platou,Perioada,
	   Amplit,valoare,max,min,NrEsVi;
    double procent;

       /*se genereaza caracteristicile aleator*/
    do
       {
       Inspir=rand()*(Tmax-4*NrEsant)/(RAND_MAX*1.0)+NrEsant;
       Expir=rand()*(Tmax-4*NrEsant)/(RAND_MAX*1.0)+NrEsant;
       Platou=rand()*(Tmax-4*NrEsant)/(RAND_MAX*1.0)+NrEsant;
       }
    while (Inspir+Platou+Expir>Tmax);
    Perioada=Inspir+Platou+Expir;
    punct1=(rand()+0.3*RAND_MAX)/(RAND_MAX*1.3);
    punct2=(rand()+0.3*RAND_MAX)/(RAND_MAX*1.3)*0.8;
    punct3=(rand()+0.3*RAND_MAX)/(RAND_MAX*1.3);
    do
       NrVirf=(rand()/(RAND_MAX*1.0)*Platou/NrEsant+1.0)/2.0+0.5;
    while ((NrVirf<1)||(NrVirf>4));
    tab=Matrice(4*NrVirf-1,2);
    procente=Vector(NrIesiri);
    if ((!tab)||(!procente))
       {
       if (tab)
	  DealocMatrice(tab,4*NrVirf-1);
       return;
       }
    tab[0][0]=0.0;
    tab[0][1]=Inspir;
    NrEsVi=Platou/(2.0*NrVirf-1.0);
    for (i=1;i<4*NrVirf-1;i++)
	{
	Amplit=rand()/(RAND_MAX*1.0)*Riplu;
	if (i%2==0)
	   tab[i][0]=0.0;
	else
	   if (i%4==1)
	      tab[i][0]=(rand()/(RAND_MAX*1.0)+1)/2.0*Amplit;
	   else
	      tab[i][0]=-(rand()/(RAND_MAX*1.0)+1)/2*Amplit;
	if (i!=1)
	   tab[i][1]=(NrEsVi-(tab[i-1][1]-Inspir)/(i-1))/2+tab[i-1][1]+1.4*rand()/(RAND_MAX*1.0)-0.7;
	else
	   tab[1][1]=NrEsVi/2+Inspir+1.4*rand()/(RAND_MAX*1.0)-0.7;
	if (i==4*NrVirf-2)
	   tab[i][1]=Inspir+Platou;
	}

	/*se reprezinta grafic functia*/
    interx=(xdrjos-xstsus)*Perioada/Tmax;
    intery=(ydrjos-ystsus)/(0.9+Riplu);
    setlinestyle(SOLID_LINE,1,NORM_WIDTH);
    setcolor(getmaxcolor());
    setviewport(xstsus,ystsus,xdrjos,ydrjos, 1);
    clearviewport();
    if ((optim=='c')&&(TipFour=='t'))
      {
      moveto(0,(intery+punct1*intery)/2);
      for (i=1;i<=interx;i++)
	{
	valoare=f(Inspir,Expir,Platou,Perioada/interx*i,NrVirf,tab);
	if (Perioada/interx*i<Inspir+Platou)
	   {
	   valoare*=1.11111*(punct2+punct1);
	   valoare-=punct1;
	   }
	else
	   if (Perioada/interx*i<Perioada)
	      {
	      valoare*=1.11111*(punct2+punct3);
	      valoare-=punct3;
	      }
	   else
	      valoare=0.0;
	lineto(i,(intery-valoare*intery)/2);
	}
      lineto(i,intery/2);
      lineto(xdrjos,intery/2);
      }

	/*se calculeaza intrarile*/
    moveto(0,(intery+punct1*intery)/2);

    for  (i=0;i<NrIntrari;i++)
	 {
	 valoare=f(Inspir,Expir,Platou,i,NrVirf,tab);
	 if (i<Inspir+Platou)
	   {
	   valoare*=1.11111*(punct2+punct1);
	   valoare-=punct1;
	   }
	else
	   if (i<Perioada)
	      {
	      valoare*=1.11111*(punct2+punct3);
	      valoare-=punct3;
	      }
	   else
	      valoare=0.0;
	 p_in[i]=valoare;
	 if ((optim=='c')&&(TipFour=='t'))
	    circle(interx/Perioada*i,(intery-p_in[i]*intery)/2,2);
	 else
	    {
	    if (TipFour=='t')
	       lineto(interx/Perioada*i,(intery-p_in[i]*intery)/2);
	    }
	 }
    if (TipFour=='f')
	{
	Fourier(NULL,NrIntrari,p_in);
	moveto(0,(intery-p_in[0]*intery)/2);
	for  (i=0;i<NrIntrari;i++)
	     lineto(interx/Perioada*i,(intery-p_in[i]*intery)/2);
	}
    if (TipFour=='c')
	{
	for  (i=0;i<NrIntrari/2;i++)
	   p_in[i+NrIntrari/2]=p_in[i];
	Fourier(NULL,NrIntrari/2,p_in);
	moveto(0,(intery-p_in[0]*intery)/2);
	for  (i=0;i<NrIntrari;i++)
	     lineto(interx/Perioada*i/2,(intery-p_in[i]*intery)/2);
	}
	/*se calculeaza iesirile*/
    ch=Clasificare((punct1+punct2)/Inspir,0.4154/(Tmax-3*NrEsant),1.8/NrEsant,&procent);
    p_out[0]=(ch%2)-0.1;
    p_out[1]=(ch/2)-0.1;
    procente[0]=procent;
    ch=Clasificare(Platou,NrEsant,Tmax-3*NrEsant,&procent);
    p_out[2]=(ch%2)-0.1;
    p_out[3]=(ch/2)-0.1;
    procente[1]=procent;
    ch=Clasificare((punct2+punct3)/Expir,0.4154/(Tmax-3*NrEsant),1.8/NrEsant,&procent);
    p_out[4]=(ch%2)-0.1;
    p_out[5]=(ch/2)-0.1;
    procente[2]=procent;
    ch=Clasificare(Perioada,3*NrEsant,Tmax,&procent);
    p_out[6]=(ch%2)-0.1;
    p_out[7]=(ch/2)-0.1;
    procente[3]=procent;
    p_out[9]=(NrVirf>2)?(NrVirf%2-0.1):((NrVirf-1)%2-0.1);
    p_out[10]=(NrVirf-1)/2-0.1;
    for (i=0;i<11;i++)
	p_out[i]=(p_out[i]>0)?p_out[i]:(-p_out[i]);

    for (i=0,min=Riplu,max=-Riplu;i<4*NrVirf-1;i++)
	{
	min=(min>tab[i][0])?tab[i][0]:min;
	max=(max<tab[i][0])?tab[i][0]:max;
	}
    procente[4]=(max-min)/2/Riplu*punct2/0.8;
    if (procente[4]>0.5)
	p_out[8]=0.9;
    else
	p_out[8]=0.1;

      /*Afisare*/
    setviewport(FereastraFolosire, 1);
    if (optim=='c')
	{
	ybin=Vector(NrIesiri);
	if (ybin)
	   {
	   CalculIesiriBinare(ybin,p_out);
	   AfisareIesiri(ybin,procente,0);
	   DealocVector(ybin);
	   }
	}
    DealocVector(procente);
    DealocMatrice(tab,4*NrVirf-1);
    }



void RealizeazaExemplar(double *pointer_in,double *pointer_out,int *ni,int *ny)
  {
  int NrIntrari,NrIesiri;
  double Tmax;
  NrIntrari=*ni;
  NrIesiri=*ny;
  if (TipFour=='c')
     Tmax=NrIntrari*0.5;
  else
     Tmax=NrIntrari*1.0;
  afiseaza_functie(FereastraFunctie,Tmax,pointer_in,pointer_out,NrIntrari,NrIesiri);
  }