#pragma inline
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <mem.h>
#include <dir.h>
#include <alloc.h>
#include "definiri.h"

extern far FILE *pfis;
extern far char cale[MAXPATH];
extern far unsigned char semnal[MaxSemnal];
extern far unsigned char *semnal_temp;
extern far char memorat;

void Out_octet(unsigned char *octet)
  {
    asm mov dx,3bch
    asm mov al,octet
    asm out dx,al
  }

void In_octet(unsigned char *octet)
  {
    asm mov dx,3bdh
    asm in al,dx
    asm mov octet,al
  }

void Temporizare_1us(void)
  {
  int i;
  extern far int numar_1us;
  for (i=0;i<numar_1us;i++);
  }


unsigned char Achiz_octet(void)
  {
  unsigned char octet,comp,poz;
  for (poz=0x80,octet=0x00;poz;poz=poz>>1)
	 {
	 octet=poz|octet;
	 Out_octet(&octet);
	 In_octet(&comp);
	 comp=comp&0x80;
	 if (!comp)
	    {
	    comp=0xFF^poz;
	    octet=octet&comp;
	    }
	 Temporizare_1us();
	 }
  return (octet);
  }

void UrmarireSemnal(char simulare,int st,int sus,int dr,int jos)
  {
  unsigned char octet;
  int nrpct,antpct,valoare,contor_semnal=0;
  unsigned char val,inregistrare=NuExista;
  char ch=13,buffer[5];
  long curpoz=0,antpoz=0,ant=0,antsec=0,contor=0,start_inreg=0;
  struct time timpcur,timpinit;


  outtextxy(50,getmaxy()-19,"Urmarire ! Spatiu/ESC inregistrare/oprire ? ");
  setviewport(st,sus,dr,jos,1);
  clearviewport();
  setcolor(getmaxcolor());
  setfillstyle(SOLID_FILL,getbkcolor());
  nrpct=dr-st;
  semnal_temp=farmalloc(MaxTimp*sizeof(unsigned char));
  if (simulare=='y')
     {
     if ((pfis=fopen(cale,"rb"))==NULL)
	{
	outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
	farfree(semnal_temp);
	return;
	}
     fread(semnal_temp,sizeof(char),MaxTimp,pfis);
     }
  antpct=0;
  moveto(0,jos-sus-semnal_temp[0]/255.0*(jos-sus));
  gettime(&timpinit);
  while (ch!=27)
    {
    gettime(&timpcur);
    curpoz=0;
    if (timpcur.ti_hour>timpinit.ti_hour)
      curpoz+=360000+6000*(timpcur.ti_min-timpinit.ti_min);
    if (timpcur.ti_min>timpinit.ti_min)
      curpoz+=6000;
    curpoz+=100*(timpcur.ti_sec-timpinit.ti_sec);
    curpoz+=timpcur.ti_hund-timpinit.ti_hund;
    if (antpoz!=curpoz)
	{
	if (simulare!='y')
	   {
	   semnal_temp[curpoz]=Achiz_octet();
	   setviewport(st,sus,dr,jos,1);
	   }
	antpoz=curpoz;
	if (curpoz<MaxTimp)
	  {
	  valoare=(float)curpoz/MaxTimp*nrpct;
	  if (antpct!=valoare)
	    {
	    line(valoare,jos-sus-semnal_temp[curpoz]/255.0*(jos-sus),antpct,jos-sus-semnal_temp[ant]/255.0*(jos-sus));
	    antpct=valoare;
	    ant=curpoz;
	    }
	  if (antsec!=curpoz/100)
	     {
	     antsec=curpoz/100;
	     contor++;
	     sprintf(buffer,"%ld",contor);
	     bar(0,0,50,10);
	     outtextxy(0,0,buffer);
	     }
	  }
       else
	  {
	  if (inregistrare==Exista)
	     {
		if (contor_semnal+MaxTimp-start_inreg<MaxSemnal)
		   {
		   memcpy(&(semnal[contor_semnal]),&(semnal_temp[start_inreg]),(MaxTimp-start_inreg)*sizeof(unsigned char));
		   contor_semnal+=MaxTimp-start_inreg;
		   start_inreg=0;
		   }
		else
		   {
		   memcpy(&(semnal[contor_semnal]),&(semnal_temp[start_inreg]),(MaxSemnal-contor_semnal)*sizeof(unsigned char));
		   setfillstyle(SOLID_FILL,getmaxcolor()/2);
		   setviewport(0,0,getmaxx(),getmaxy(),1);
		   bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
		   outtextxy(50,getmaxy()-19,"Urmarire ! Spatiu/ESC inregistrare/oprire ? ");
		   setviewport(st,sus,dr,jos,1);
		   setfillstyle(SOLID_FILL,getbkcolor());
		   memorat='d';
		   inregistrare=NuExista;
		   }
	     }
	  if (simulare=='y')
	     {
	     fread(semnal_temp,sizeof(char),MaxTimp,pfis);
	     if (feof(pfis))
		break;
	     }
	  memcpy(&timpinit,&timpcur,4*sizeof(unsigned char));
	  clearviewport();
	  moveto(0,jos-sus-semnal_temp[curpoz]/255.0*(jos-sus));
	  antpct=0;
	  }

       if (kbhit())
	  {
	  ch=getch();
	  if(!ch)
	    {
	    ch=getch();
	    ch=0;
	    }
	  }
       if (ch==32)
	  {
	  setfillstyle(SOLID_FILL,getmaxcolor()/2);
	  setviewport(0,0,getmaxx(),getmaxy(),1);
	  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
	  outtextxy(50,getmaxy()-19,"Inregistrare !!! ");
	  setviewport(st,sus,dr,jos,1);
	  setfillstyle(SOLID_FILL,getbkcolor());
	  inregistrare=Exista;
	  contor_semnal=0;
	  start_inreg=curpoz;
	  ch=13;
	  }
       if (inregistrare==Exista)
	  ch=13;
       }
     }
  setviewport(st,sus,dr,jos,1);
  clearviewport();
  setviewport(0,0,getmaxx(),getmaxy(),1);
  fclose(pfis);
  farfree(semnal_temp);
  }