#include <graphics.h>
#include <alloc.h>
#include <dir.h>
#include <dos.h>
#include <conio.h>
#include "definiri.h"


extern far void Incarcare(void);
extern far void ScrieFisier(char c[]);
extern far void ReteaNoua(void);
extern far void Antrenare(void);
extern far void ModificaParametri(void);
extern far void Folosire(void);
extern far void UrmarireSemnal(char sir,int st,int sus,int dr,int jos);
extern far void CitireLista(char indicator,char exist);
extern far char CitesteFisier(char ext[MAXFILE+MAXEXT+1],char i,char *j);
extern far void AfisareParametri(void);
extern far void TipFourier(void);
extern far void Optimizare(void);
extern far void AutoSalvare(void);
extern far void Simulare(void);
extern far void Demo(void);
extern far void Analiza(void);
extern far char cale[];
extern far void *Imagine(int N);
extern far void DealocImagine(void *v);
extern far void Help(char ch,int st,int sus,int dr,int jos);
extern far void CitireSemnal(void);
extern far char memorat;

void Ecran(void);
char Lansare(int poz);
void Urmarire(void);

char Meniu[6][10][20]={{"Folosire"," Retea","Simulare","Demonstratie"," Semnal","Urmarire","Analiza","\\","\\","\\"},
		       {"Retea","Incarcare","Salvare","Retea Noua","Antrenare","Parametri","\\","\\","\\","\\"},
		       {"Semnal","Incarcare","Salvare","Modificare","Extern","\\","\\","\\","\\","\\"},
		       {"Optiuni","Simulare","Optimizare","Auto Salvare","Fourier","\\","\\","\\","\\","\\"},
		       {"Indicatii","Aplicatii","Comenzi","\\","\\","\\","\\","\\","\\","\\"},
		       {"Iesire","Nu","Da","\\","\\","\\","\\","\\","\\","\\"}};
unsigned int DimensMeniu[6][4]= {{80,5,122,80},       /*latime meniu    */
				 {56,85,98,50},       /*pozite x meniu  */
				 {64,141,106,40},     /*latime submeniu */
				 {72,205,122,40},     /*inaltime submeniu*/
				 {88,277,98,20},      /*                */
				 {64,365,42,20}};     /*                */
unsigned dimens_max_meniu=88;
unsigned dimens_max_submeniu_oriz=132;
unsigned dimens_max_submeniu_vert=90;
extern char simulare;
char TipFour='t';

void Ecran(void)
  {
  int i;
  char sir[10];
  setcolor(getmaxcolor());
  setpalette(BLACK,BLUE);
  setpalette(YELLOW,WHITE);
  setlinestyle(SOLID_LINE,1,THICK_WIDTH);
  setfillstyle(SOLID_FILL,1);
  bar(BaraMeniu);
  setfillstyle(SOLID_FILL,getmaxcolor()/2);
  settextjustify(CENTER_TEXT,TOP_TEXT);
  for (i=0;i<6;i++)
      outtextxy(DimensMeniu[i][1]+DimensMeniu[i][0]/2,4,Meniu[i][0]);
  settextjustify(LEFT_TEXT,TOP_TEXT);
  setcolor(LIGHTCYAN);
  rectangle(5,20,getmaxx()-5,getmaxy()-5);
  rectangle(getmaxx()-150,20,getmaxx()-5,getmaxy()-5);
  rectangle(5,getmaxy()-25,getmaxx()-150,getmaxy()-5);
  setlinestyle(SOLID_LINE,1,NORM_WIDTH);
  rectangle(ChenarFunctie);
  bar(BaraStare);
  outtextxy(getmaxx()-135,par,"Parametri");
  outtextxy(getmaxx()-145,par+10,"Intrari");
  outtextxy(getmaxx()-145,par+20,"Iesiri");
  outtextxy(getmaxx()-145,par+30,"Strat 1");
  outtextxy(getmaxx()-145,par+40,"Strat 2");
  outtextxy(getmaxx()-145,par+50,"Alfa");
  outtextxy(getmaxx()-145,par+60,"Eta");
  outtextxy(getmaxx()-145,par+70,"Pasi realizati");
  outtextxy(getmaxx()-145,semnale+20,"Memorat");
  outtextxy(getmaxx()-145,semnale+30,"Filtrat");
  outtextxy(getmaxx()-145,semnale+40,"Segmentat");
  outtextxy(getmaxx()-145,semnale+50,"Calculat");
  outtextxy(getmaxx()-145,optiuni+20,"Optim");
  outtextxy(getmaxx()-145,optiuni+30,"Simulare");
  outtextxy(getmaxx()-145,optiuni+40,"Salvare");
  outtextxy(getmaxx()-145,optiuni+50,"Fourier");
  outtextxy(getmaxx()-145,optiuni+100,"Initial");
  outtextxy(getmaxx()-145,optiuni+110,"Momentan");
  setcolor(LIGHTRED);
  outtextxy(getmaxx()-125,retea+10,"RETEA");
  outtextxy(getmaxx()-125,semnale,"SEMNAL");
  outtextxy(getmaxx()-125,optiuni,"OPTIUNI");
  outtextxy(getmaxx()-125,optiuni+80,"MEMORIE DISP");
  setcolor(getmaxcolor());
  outtextxy(getmaxx()-60,semnale+20,"Nu");
  outtextxy(getmaxx()-60,semnale+30,"Nu");
  outtextxy(getmaxx()-60,semnale+40,"Nu");
  outtextxy(getmaxx()-60,semnale+50,"Nu");
  outtextxy(getmaxx()-80,optiuni+20,"Claritate");
  outtextxy(getmaxx()-80,optiuni+30,"Da");
  outtextxy(getmaxx()-80,optiuni+40,"Da");
  outtextxy(getmaxx()-80,optiuni+50,"Timp");
  sprintf(sir,"%lu",farcoreleft());
  outtextxy(getmaxx()-70,optiuni+100,sir);
  outtextxy(getmaxx()-70,optiuni+110,sir);
  }


char Lansare(int poz)
  {
  char ch;
  char indic_exist;
  ch=115;
  switch(poz)
     {
     case 10 : if (CitesteFisier("*.ret",Load,&indic_exist)!=27) Incarcare();break;
     case 11 : if (CitesteFisier("*.ret",Save,&indic_exist)!=27) ScrieFisier(cale);break;
     case 12 : ReteaNoua();break;
     case 14 : ModificaParametri();AfisareParametri();break;
     case 13 : Antrenare();break;
     case 1  : Folosire();break;
     case 33 : TipFourier();break;
     case 32 : AutoSalvare();break;
     case 31 : Optimizare();break;
     case 30 : Simulare();break;
     case 2  : Demo();break;
     case 4  : if (simulare=='y')
		  {
		  if (CitesteFisier("*.sim",Load,&indic_exist)!=27)
		      UrmarireSemnal(simulare,FereastraFunctie);
		  break;
		  }
	       else
		  {
		  UrmarireSemnal(simulare,FereastraFunctie);
		  break;
		  }
     case 20 : if (CitesteFisier("*.lst",Load,&indic_exist)!=27) CitireLista(Load,indic_exist);break;
     case 21 : if (CitesteFisier("*.lst",Save,&indic_exist)!=27) CitireLista(Save,indic_exist);break;
     case 22 : if (CitesteFisier("*.lst",Load,&indic_exist)!=27) CitireLista(Modify,indic_exist);break;
     case 23 : if (CitesteFisier("*.dat",Load,&indic_exist)!=27) CitireSemnal();break;
     case 5  : if (memorat=='d') Analiza(); break;
     case 40 :
     case 41 : Help(poz-40,FereastraFunctie);break;
     case 50 : ch=32;break;
     case 51 : ch=27;break;
     default : break;
     }
  return(ch);
  }

int SubMeniu(int CurentPozOriz)
  {
  extern void *ImgSalvSubMeniu;
  extern void *ImgSalvFis;
  int CurentPozVert=0,i,max;
  unsigned dim;
  char ch;

  dim=imagesize(0,0,dimens_max_submeniu_oriz,10);
  ImgSalvSubMeniu=Imagine(dim);
  dim=imagesize(0,0,dimens_max_submeniu_oriz,dimens_max_submeniu_vert);
  ImgSalvFis=Imagine(dim);
  for (i=1;Meniu[CurentPozOriz][i][0]!='\\';i++);
  max=i-1;
  getimage(DimensMeniu[CurentPozOriz][1],15,DimensMeniu[CurentPozOriz][1]+DimensMeniu[CurentPozOriz][2],25+max*10,ImgSalvFis);
  setviewport(DimensMeniu[CurentPozOriz][1],15,DimensMeniu[CurentPozOriz][1]+DimensMeniu[CurentPozOriz][2],25+max*10,1);
  setfillstyle(SOLID_FILL,getmaxcolor()-1);
  bar(0,0,DimensMeniu[CurentPozOriz][2],max*10+10);
  setfillstyle(SOLID_FILL,1);
  bar(5,5,DimensMeniu[CurentPozOriz][2]-5,max*10+5);
  setcolor(getmaxcolor());
  for (i=1;Meniu[CurentPozOriz][i][0]!='\\';i++)
      {
      if (Meniu[CurentPozOriz][i][0]==' ')
	 {
	 setcolor(LIGHTRED);
	 outtextxy(10,10*i-4,Meniu[CurentPozOriz][i]);
	 setcolor(getmaxcolor());
	 }
      else
	 outtextxy(10,10*i-4,Meniu[CurentPozOriz][i]);
      }
  while(Meniu[CurentPozOriz][CurentPozVert+1][0]==' ')
       CurentPozVert++;
  do
    {
    getimage(10,CurentPozVert*10+5,DimensMeniu[CurentPozOriz][2]-10,15+CurentPozVert*10,ImgSalvSubMeniu);
    putimage(10,CurentPozVert*10+5,ImgSalvSubMeniu,NOT_PUT);
    do {} while (kbhit()==0);
    ch=getch();
    if (ch==0)
	ch=getch();
    switch(ch)
	{
	case 80 : {
		  getimage(10,CurentPozVert*10+5,DimensMeniu[CurentPozOriz][2]-10,15+CurentPozVert*10,ImgSalvSubMeniu);
		  putimage(10,CurentPozVert*10+5,ImgSalvSubMeniu,NOT_PUT);
		  if (CurentPozVert<max-1)
		     CurentPozVert++;
		  if (Meniu[CurentPozOriz][CurentPozVert+1][0]==' ')
		     CurentPozVert++;
		  break;
		  }
	case 72 :
		  {
		  getimage(10,CurentPozVert*10+5,DimensMeniu[CurentPozOriz][2]-10,15+CurentPozVert*10,ImgSalvSubMeniu);
		  putimage(10,CurentPozVert*10+5,ImgSalvSubMeniu,NOT_PUT);
		  if (CurentPozVert>0)
		      CurentPozVert--;
		  if (Meniu[CurentPozOriz][CurentPozVert+1][0]==' ')
		     CurentPozVert--;
		  if (CurentPozVert<0)
		     CurentPozVert+=2;
		  break;
		  }
	case 13 :
		  {
		  getimage(10,CurentPozVert*10+5,DimensMeniu[CurentPozOriz][2]-10,15+CurentPozVert*10,ImgSalvSubMeniu);
		  putimage(10,CurentPozVert*10+5,ImgSalvSubMeniu,NOT_PUT);
		  goto etich1;
		  }
	default :
		  getimage(10,CurentPozVert*10+5,DimensMeniu[CurentPozOriz][2]-10,15+CurentPozVert*10,ImgSalvSubMeniu);
		  putimage(10,CurentPozVert*10+5,ImgSalvSubMeniu,NOT_PUT);
	}
    }
  while (ch!=27);

etich1:
  if (ch==27)
     CurentPozVert=-1;
  setviewport(0,0,getmaxx(),getmaxy(),1);
  putimage(DimensMeniu[CurentPozOriz][1],15,ImgSalvFis,COPY_PUT);
  DealocImagine(ImgSalvFis);
  DealocImagine(ImgSalvSubMeniu);
  return(CurentPozVert);
  }

void Urmarire(void)
  {
  int i,j;
  char ch;
  int CurentPozOriz=0;
  unsigned dim;
  extern void *ImgSalvMeniu;
  extern void *ImgSalvSubMeniu;
  dim=imagesize(0,0,dimens_max_meniu,15);
  ImgSalvMeniu=Imagine(dim);
  do
    {
    getimage(DimensMeniu[CurentPozOriz][1],0,DimensMeniu[CurentPozOriz][0]+DimensMeniu[CurentPozOriz][1],15,ImgSalvMeniu);
    putimage(DimensMeniu[CurentPozOriz][1],0,ImgSalvMeniu,NOT_PUT);
    do {} while (kbhit()==0);
    ch=getch();
    if(!ch)
       ch=getch();
    switch(ch)
	{
	case 77 : {
		  getimage(DimensMeniu[CurentPozOriz][1],0,DimensMeniu[CurentPozOriz][0]+DimensMeniu[CurentPozOriz][1],15,ImgSalvMeniu);
		  putimage(DimensMeniu[CurentPozOriz][1],0,ImgSalvMeniu,NOT_PUT);
		  if (CurentPozOriz<5)
		  CurentPozOriz++;
		  break;
		  }
	case 75 :
		  {
		  getimage(DimensMeniu[CurentPozOriz][1],0,DimensMeniu[CurentPozOriz][0]+DimensMeniu[CurentPozOriz][1],15,ImgSalvMeniu);
		  putimage(DimensMeniu[CurentPozOriz][1],0,ImgSalvMeniu,NOT_PUT);
		  if (CurentPozOriz>0)
		      CurentPozOriz--;
		  break;
		  }
	case 13 :
		  {
		  getimage(DimensMeniu[CurentPozOriz][1],0,DimensMeniu[CurentPozOriz][0]+DimensMeniu[CurentPozOriz][1],15,ImgSalvMeniu);
		  putimage(DimensMeniu[CurentPozOriz][1],0,ImgSalvMeniu,NOT_PUT);
		  ch=SubMeniu(CurentPozOriz);
		  if (ch==-1)
		     break;
		  ch=Lansare(10*CurentPozOriz+ch);
		  if (ch==27)
		     goto etich;
		  break;
		  }
	default :
		  getimage(DimensMeniu[CurentPozOriz][1],0,DimensMeniu[CurentPozOriz][0]+DimensMeniu[CurentPozOriz][1],15,ImgSalvMeniu);
		  putimage(DimensMeniu[CurentPozOriz][1],0,ImgSalvMeniu,NOT_PUT);
	}
    }
  while (1);
etich:
  DealocImagine(ImgSalvMeniu);
  }
