#include <graphics.h>
#include <stdio.h>
#include <dir.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <process.h>
#include "definiri.h"
#include "tipuri.h"

extern far FILE *pfis_list;
extern far FILE *pfis;
extern far char simulare;
extern far char cale[MAXPATH];
extern far char dir[MAXPATH];
extern far void *Imagine(int N);
extern far void DealocImagine(void *v);
extern far void Afiseaza_Semnal(unsigned char *semnal,int st,int sus,int dr,int jos);
extern far void CitesteSir(char *sir_util,int dimens,int poz);
extern far char CitesteFisier(char ext[MAXFILE+MAXEXT+1],char i,char *j);
extern far void Ecran(void);
extern far void AfisareParametri(void);

extern far unsigned char semnal[MaxSemnal];
extern far char memorat;
extern far char filtrat;
extern far char segmentat;
extern far char calculat;
extern far int f_max,f_min,f_mediu,Cap_Vit,Vol_Cur,Vol_min,V_EMS,V_IMS,Deb_Vent,Deb_V_max,Ktiff;
extern far int indicator;

Inregistrare_Lista inreg;
Inregistrare_Lista inreg_temp;
char cale_temp[MAXPATH];
char inutil[MAXPATH];
char nume_fis[15];
char nume_ext[5];

void CitireSemnal(void)
  {
  if ((pfis=fopen(cale,"rb"))==NULL)
     {
     outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
     return;
     }
  fread(semnal,sizeof(char),MaxSemnal,pfis);
  fclose(pfis);

  memorat='d';
  filtrat='n';
  segmentat='n';
  calculat='n';
  setviewport(0,0,getmaxx(),getmaxy(),1);
  setfillstyle(SOLID_FILL,getbkcolor());
  setcolor(getmaxcolor());
  bar(getmaxx()-60,semnale+19,getmaxx()-7,semnale+29);
  outtextxy(getmaxx()-60,semnale+20,"Da");
  bar(getmaxx()-60,semnale+29,getmaxx()-7,semnale+39);
  outtextxy(getmaxx()-60,semnale+30,"Nu");
  bar(getmaxx()-60,semnale+39,getmaxx()-7,semnale+49);
  outtextxy(getmaxx()-60,semnale+40,"Nu");
  bar(getmaxx()-60,semnale+49,getmaxx()-7,semnale+59);
  outtextxy(getmaxx()-60,semnale+50,"Nu");
  }

void Realizeaza_Inregistrare(Inregistrare_Lista *inreg)
  {
  int i,temp;
  char ch;
  char exist;
  char buff[3];
  setfillstyle(SOLID_FILL,getmaxcolor()/2);
  setcolor(getmaxcolor());
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Nume :");
  CitesteSir(inreg->nume,19,67);
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Prenume :");
  CitesteSir(inreg->prenume,14,90);
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Virsta :");
  CitesteSir(inreg->virsta,2,80);
  getdate(&(inreg->data_test));
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Semnal din memorie/disc (m/d) ?:");
  ch=tolower(getch());
  while ((ch!='d')&&(ch!='m'))
	ch=tolower(getch());
  if (ch=='d')
     {
     strcpy(cale_temp,cale);
     do ch=CitesteFisier("*.dat",Load,&exist); while(ch==27);
     if ((pfis=fopen(cale,"rb"))==NULL)
	{
	outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
	return;
	}
     fread(semnal,sizeof(char),MaxSemnal,pfis);
     fclose(pfis);
     strcpy(cale,cale_temp);
     }
  memset(&(inreg->cale_date),0,12);
  inreg->cale_date[0]=inreg->nume[0];
  inreg->cale_date[1]=inreg->prenume[0];
  strcat(inreg->cale_date,inreg->virsta);
  sprintf(buff,"%02d",(inreg->data_test).da_day);
  strcat(inreg->cale_date,buff);
  sprintf(buff,"%02d",(inreg->data_test).da_mon);
  strcat(inreg->cale_date,buff);
  strcat(inreg->cale_date,".dat");
  if ((pfis=fopen("semnal.tmp","wb"))==NULL)
	  {
	  outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
	  return;
	  }
  for (i=MaxSemnal-1;i>0;i--)
	 {
	 temp=semnal[i]-semnal[i-1]+128;
	 semnal[i]=(unsigned char)temp;
	 }
  fwrite(semnal,sizeof(char),MaxSemnal,pfis);
  fclose(pfis);
  cleardevice();
  temp=spawnl(P_WAIT,"arj.exe","a","a",inreg->cale_date,"semnal.tmp",NULL);
  if (temp == -1)
     {
     perror("Eroare lansare arj");
     getch();
     }
  unlink("semnal.tmp");
  cleardevice();
  Ecran();
  setviewport(0,0,getmaxx(),getmaxy(),1);
  if (indicator==1)
     AfisareParametri();
  if (filtrat=='d')
     (inreg->rezultate).filtrat='d';
  if (calculat=='d')
     {
     (inreg->rezultate).calculat='d';
     (inreg->rezultate).f_max=f_max;
     (inreg->rezultate).f_min=f_min;
     (inreg->rezultate).f_mediu=f_mediu;
     (inreg->rezultate).Cap_Vit=Cap_Vit;
     (inreg->rezultate).Vol_Cur=Vol_Cur;
     (inreg->rezultate).Vol_min=Vol_min;
     (inreg->rezultate).V_EMS=V_EMS;
     (inreg->rezultate).V_IMS=V_IMS;
     (inreg->rezultate).Deb_Vent=Deb_Vent;
     (inreg->rezultate).Deb_V_max=Deb_V_max;
     (inreg->rezultate).Ktiff=Ktiff;
     }
  bar(7,getmaxy()-23,getmaxx()-152,getmaxy()-7);
  outtextxy(20,getmaxy()-19,"Tiparire (d/n) ?:");
  ch=tolower(getch());
  while ((ch!='d')&&(ch!='n'))
	ch=tolower(getch());
  if (ch=='d')
     {
     fprintf(stdprn,"   DATE PERSONALE\n\n");
     fprintf(stdprn,"Nume       : %s\n",inreg->nume);
     fprintf(stdprn,"Prenume    : %s\n",inreg->prenume);
     fprintf(stdprn,"Varsta     : %s\n",inreg->virsta);
     fprintf(stdprn,"Data test  : %02d/%02d/%04d\n\n",(inreg->data_test).da_day,(inreg->data_test).da_mon,(inreg->data_test).da_year);
     fprintf(stdprn,"   REZULTATE\n\n");
     fprintf(stdprn,"frecventa maxima                  %3.1f  (resp/min)\n",f_max/10.0);
     fprintf(stdprn,"frecventa minima                  %3.1f  (resp/min)\n",f_min/10.0);
     fprintf(stdprn,"frecventa medie                   %3.1f  (resp/min)\n",f_mediu/10.0);
     fprintf(stdprn,"Capacitate Vitala (volum maxim)   %4d  (ml)\n",Cap_Vit);
     fprintf(stdprn,"Volum Curent (volum mediu)        %4d  (ml)\n",Vol_Cur);
     fprintf(stdprn,"Volum minim                       %4d  (ml)\n",Vol_min);
     fprintf(stdprn,"Volum Expirator Maxim pe Secunda  %4d  (ml/s)\n",V_EMS);
     fprintf(stdprn,"Volum Inspirator Maxim pe Secunda %4d  (ml/s)\n",V_IMS);
     fprintf(stdprn,"Debit ventilator                 %4.2f  (l/min)\n",Deb_Vent/10.0);
     fprintf(stdprn,"Debit ventilator maxim           %4.2f  (l/min)\n",Deb_V_max/10.0);
     fprintf(stdprn,"Indicele Tiffeneau                  %2d    (%)\n\n",Ktiff);
     }
  }

unsigned Cauta_Primul(void)
  {
  unsigned curent=1;
  fseek(pfis_list,0L,SEEK_SET);
  do
      {
      fread(&inreg_temp,sizeof(Inregistrare_Lista),1,pfis_list);
      curent=(inreg_temp.precedent)?inreg_temp.precedent:curent;
      fseek(pfis_list,(inreg_temp.precedent-1)*sizeof(Inregistrare_Lista),SEEK_SET);
      }
  while(inreg_temp.precedent);
  return(curent);
  }

void Detecteaza_Pozitie(Inregistrare_Lista *inreg)
  {
  int temp;
  unsigned curent;
  curent=Cauta_Primul();
  fseek(pfis_list,(curent-1)*sizeof(Inregistrare_Lista),SEEK_SET);
  do
      {
      memset(&inreg_temp,0,sizeof(Inregistrare_Lista));
      fread(&inreg_temp,sizeof(Inregistrare_Lista),1,pfis_list);
      temp=stricmp(inreg_temp.nume,inreg->nume);
      if ((temp>0)||((temp==0)&&((temp=stricmp(inreg_temp.prenume,inreg->prenume))>0)))
	 break;
      inreg_temp.precedent=(inreg_temp.urmator)?inreg_temp.precedent:curent;
      curent=inreg_temp.urmator;
      fseek(pfis_list,(inreg_temp.urmator-1)*sizeof(Inregistrare_Lista),SEEK_SET);
      }
  while(inreg_temp.urmator);
  inreg->precedent=inreg_temp.precedent;
  inreg->urmator=curent;
  }

void Afiseaza_Lista(unsigned poz_init,unsigned *lista)
  {
  int i;
  char buf[15];
  setviewport(FereastraLista,1);
  lista[1]=poz_init;
  setfillstyle(SOLID_FILL,getmaxcolor()/2);
  bar(5,20,LatimeLista,70);
  fseek(pfis_list,(poz_init-1)*sizeof(Inregistrare_Lista),SEEK_SET);
  for (i=0;i<5;i++)
      {
      fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
      lista[i]=inreg.precedent;
      lista[i+2]=inreg.urmator;
      outtextxy(5,22+10*i,inreg.nume);
      outtextxy(170,22+10*i,inreg.prenume);
      outtextxy(295,22+10*i,inreg.virsta);
      sprintf(buf,"%02d/%02d/%04d",(inreg.data_test).da_day,(inreg.data_test).da_mon,(inreg.data_test).da_year);
      outtextxy(348,22+10*i,buf);
      if (inreg.urmator)
	 fseek(pfis_list,(inreg.urmator-1)*sizeof(Inregistrare_Lista),SEEK_SET);
      else
	 break;
      }
  }

unsigned Urmareste_Lista(void)

  {
  extern void *ImgSalvSubMeniu;
  extern void *ImgSalvFis;
  unsigned CurentPozVert=2,i,max;
  unsigned dim;
  char ch;
  unsigned lista[7];

     dim=imagesize(0,0,LatimeLista,10);
     ImgSalvSubMeniu=Imagine(dim);
     dim=imagesize(FereastraLista);
     ImgSalvFis=Imagine(dim);
     getimage(FereastraLista,ImgSalvFis);
     setfillstyle(SOLID_FILL,getmaxcolor()/2);
     bar(FereastraLista);
     setviewport(FereastraLista,1);
     setcolor(getbkcolor());
     outtextxy(5,10,"Nume");
     outtextxy(170,10,"Prenume");
     outtextxy(295,10,"Virsta");
     outtextxy(348,10,"Data");

     Afiseaza_Lista(Cauta_Primul(),lista);
     do
	{
	getimage(0,CurentPozVert*10,LatimeLista,10+CurentPozVert*10,ImgSalvSubMeniu);
	putimage(0,CurentPozVert*10,ImgSalvSubMeniu,NOT_PUT);
	do {} while (kbhit()==0);
	ch=getch();
	if (ch==0)
	   ch=getch();
	switch(ch)
	   {
	   case 80 : {
		  getimage(0,CurentPozVert*10,LatimeLista,10+CurentPozVert*10,ImgSalvSubMeniu);
		  putimage(0,CurentPozVert*10,ImgSalvSubMeniu,NOT_PUT);
		  if (CurentPozVert<5+1)
		     CurentPozVert++;
		  else
		     if (lista[6])
			Afiseaza_Lista(lista[2],lista);
		  break;
		  }
	   case 72 :
		  {
		  getimage(0,CurentPozVert*10,LatimeLista,10+CurentPozVert*10,ImgSalvSubMeniu);
		  putimage(0,CurentPozVert*10,ImgSalvSubMeniu,NOT_PUT);
		  if (CurentPozVert>2)
		     CurentPozVert--;
		  else
		     if (lista[0])
			Afiseaza_Lista(lista[0],lista);
		  break;
		  }
	   case 13 :
		  {
		  getimage(0,CurentPozVert*10,LatimeLista,10+CurentPozVert*10,ImgSalvSubMeniu);
		  putimage(0,CurentPozVert*10,ImgSalvSubMeniu,NOT_PUT);
		  goto etich1;
		  }
	   default :
		  getimage(0,CurentPozVert*10,LatimeLista,10+CurentPozVert*10,ImgSalvSubMeniu);
		  putimage(0,CurentPozVert*10,ImgSalvSubMeniu,NOT_PUT);
	   }
	}
	while (ch!=27);

etich1:
     if (ch==27)
	lista[CurentPozVert-1]=0;
     setviewport(0,0,getmaxx(),getmaxy(),1);
     putimage(ColtLista,ImgSalvFis,COPY_PUT);
     DealocImagine(ImgSalvFis);
     DealocImagine(ImgSalvSubMeniu);
     return(lista[CurentPozVert-1]);
  }

void CitireLista(char indicat,char exist)
  {
  int i,temp;
  long sfirsit;
  unsigned temp1,temp2;
  switch (indicat)
  {
   case Load:
     if ((pfis_list=fopen(cale,"rb"))==NULL)
	{
	outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
	return;
	}
     temp1=Urmareste_Lista();
     if (temp1)
	{
	memset(&inreg,0,sizeof(Inregistrare_Lista));
	fseek(pfis_list,(temp1-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	cleardevice();
	temp=spawnl(P_WAIT,"arj.exe","e","e",inreg.cale_date,"semnal.tmp",NULL);
	if (temp == -1)
	  {
	  perror("Eroare lansare arj");
	  getch();
	  }
	cleardevice();
	Ecran();
	setviewport(0,0,getmaxx(),getmaxy(),1);
	if (indicator==1)
	   AfisareParametri();
	if ((pfis=fopen("semnal.tmp","rb"))==NULL)
	  {
	  outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
	  return;
	  }
	fread(semnal,sizeof(char),MaxSemnal,pfis);
	fclose(pfis);
	unlink("semnal.tmp");
	for (i=1;i<MaxSemnal;i++)
	 {
	 temp=semnal[i]+semnal[i-1]-128;
	 semnal[i]=(unsigned char)temp;
	 }
	setviewport(0,0,getmaxx(),getmaxy(),1);
	setfillstyle(SOLID_FILL,getbkcolor());
	setcolor(getmaxcolor());
	memorat='d';
	bar(getmaxx()-60,semnale+19,getmaxx()-7,semnale+29);
	outtextxy(getmaxx()-60,semnale+20,"Da");
	bar(getmaxx()-60,semnale+29,getmaxx()-7,semnale+39);
	if ((inreg.rezultate).filtrat=='d')
	   {
	   filtrat='d';
	   outtextxy(getmaxx()-60,semnale+30,"Da");
	   }
	else
	   {
	   filtrat='n';
	   outtextxy(getmaxx()-60,semnale+30,"Nu");
	   }
	bar(getmaxx()-60,semnale+39,getmaxx()-7,semnale+49);
	segmentat='n';
	outtextxy(getmaxx()-60,semnale+40,"Nu");
	bar(getmaxx()-60,semnale+49,getmaxx()-7,semnale+59);
	if ((inreg.rezultate).calculat=='d')
	   {
	   calculat='d';
	   outtextxy(getmaxx()-60,semnale+50,"Da");
	   }
	else
	   {
	   calculat='n';
	   outtextxy(getmaxx()-60,semnale+50,"Nu");
	   }
	f_max=(inreg.rezultate).f_max;
	f_min=(inreg.rezultate).f_min;
	f_mediu=(inreg.rezultate).f_mediu;
	Cap_Vit=(inreg.rezultate).Cap_Vit;
	Vol_Cur=(inreg.rezultate).Vol_Cur;
	Vol_min=(inreg.rezultate).Vol_min;
	V_EMS=(inreg.rezultate).V_EMS;
	V_IMS=(inreg.rezultate).V_IMS;
	Deb_Vent=(inreg.rezultate).Deb_Vent;
	Deb_V_max=(inreg.rezultate).Deb_V_max;
	Ktiff=(inreg.rezultate).Ktiff;
	}
     fclose(pfis_list);
     break ;
  /**/
   case Save:
     if (exist==Exista)
	{
	if ((pfis_list=fopen(cale,"r+b"))==NULL)
	   {
	   outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
	   return;
	   }
	memset(&inreg,0,sizeof(Inregistrare_Lista));
	Realizeaza_Inregistrare(&inreg);
	Detecteaza_Pozitie(&inreg);
	fseek(pfis_list,0L,SEEK_END);
	sfirsit=ftell(pfis_list);
	fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	temp1=inreg.precedent;
	temp2=inreg.urmator;
	/**/
	if (temp1)
	   {
	   memset(&inreg,0,sizeof(Inregistrare_Lista));
	   fseek(pfis_list,(temp1-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   inreg.urmator=sfirsit/sizeof(Inregistrare_Lista)+1;
	   fseek(pfis_list,(temp1-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   }
	/**/
	if (temp2)
	   {
	   memset(&inreg,0,sizeof(Inregistrare_Lista));
	   fseek(pfis_list,(temp2-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   inreg.precedent=sfirsit/sizeof(Inregistrare_Lista)+1;
	   fseek(pfis_list,(temp2-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   }
	fclose(pfis_list);
	}
     else
	{
	if ((pfis_list=fopen(cale,"wb"))==NULL)
	   {
	   outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
	   return;
	   }
	inreg.precedent=0;
	inreg.urmator=0;
	Realizeaza_Inregistrare(&inreg);
	fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	fclose(pfis_list);
	}
     break;
   case Modify :
     if ((pfis_list=fopen(cale,"r+b"))==NULL)
	   {
	   outtextxy(50,getmaxy()-19,"Fisierul nu se poate deschide");
	   return;
	   }
     temp1=Urmareste_Lista();
     if (temp1)
	{
	memset(&inreg,0,sizeof(Inregistrare_Lista));
	fseek(pfis_list,(temp1-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	sfirsit=ftell(pfis_list);
	fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	temp1=inreg.precedent;
	temp2=inreg.urmator;
	/**/
	if (temp1)
	   {
	   memset(&inreg,0,sizeof(Inregistrare_Lista));
	   fseek(pfis_list,(temp1-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   inreg.urmator=temp2;
	   fseek(pfis_list,(temp1-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   }
	/**/
	if (temp2)
	   {
	   memset(&inreg,0,sizeof(Inregistrare_Lista));
	   fseek(pfis_list,(temp2-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   inreg.precedent=temp1;
	   fseek(pfis_list,(temp2-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   }
	Realizeaza_Inregistrare(&inreg);
	Detecteaza_Pozitie(&inreg);
	fseek(pfis_list,sfirsit,SEEK_SET);
	fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	temp1=inreg.precedent;
	temp2=inreg.urmator;
	/**/
	if (temp1)
	   {
	   memset(&inreg,0,sizeof(Inregistrare_Lista));
	   fseek(pfis_list,(temp1-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   inreg.urmator=sfirsit/sizeof(Inregistrare_Lista)+1;
	   fseek(pfis_list,(temp1-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   }
	/**/
	if (temp2)
	   {
	   memset(&inreg,0,sizeof(Inregistrare_Lista));
	   fseek(pfis_list,(temp2-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fread(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   inreg.precedent=sfirsit/sizeof(Inregistrare_Lista)+1;
	   fseek(pfis_list,(temp2-1)*sizeof(Inregistrare_Lista),SEEK_SET);
	   fwrite(&inreg,sizeof(Inregistrare_Lista),1,pfis_list);
	   }
	}
     fclose(pfis_list);
     break;
  }
  }